<template>
  <div class="flex flex-col items-center justify-center">
    <promotion-filter
      v-model:radio-model="radioFilterModel"
      v-model:select-model="selectFilterModel"
      :promotion-group="promotionGroup"
    />
    <div class="flex flex-col w-full py-5 gap-7">
      <promotion-horizontal-card
        v-for="promotion in promotionListForDisplay"
        :key="promotion.Id"
        :authenticated="authenticated"
        :promotion="promotion"
        :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
        :check-promotion-group="checkPromotionGroup"
        :on-apply-promotion="onApplyPromotion"
        :is-processing="isProcessing"
        style="--promotion-dialog-content-color: var(--primary)"
        :is-hover-scale-center="true"
        :is-applying="applyRequest.PromotionId === promotion.Id"
        :validateLuckyWheelbutton="validateLuckyWheelbutton(promotion)"
        :on-click-spin-now="onClickSpinNow"
      />
      <div
        v-if="promotionListForDisplay.length === 0"
        class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden"
      >
        <div
          class="text-color overflow-hidden text-4xl text-center truncate no-data text-ellipsis"
        >
          {{ $t("no_promotion_info") }}
        </div>
        <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from "vue";

export default defineComponent({
  name: "Promotion",
  setup() {
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      checkPromotionGroup,
      assignHashText,
      applyRequest,
      promotionGroup,
      onClickPromotion,
      promotionListForDisplay,
      onClickSpinNow,
      validateLuckyWheelbutton,
    } = usePromotion();
    const radioFilterModel = ref("all offer");
    const selectFilterModel = ref(0);
    watch(radioFilterModel, () => onClickPromotion(radioFilterModel.value));

    return {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      checkPromotionGroup,
      radioFilterModel,
      // selectForFilter,
      selectFilterModel,
      promotionListForDisplay,
      assignHashText,
      applyRequest,
      promotionGroup,
      onClickPromotion,
      onClickSpinNow,
      validateLuckyWheelbutton,
    };
  },
});
</script>
